/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: exosopt.h,v 1.5 87/05/18 08:31:59 davidb Exp $ */
/*	$Header: exosopt.h,v 1.5 87/05/18 08:31:59 davidb Exp $
 *
 *	$Log:	exosopt.h,v $
 * Revision 1.5  87/05/18  08:31:59  davidb
 * PMR001994: new netload options for telnet option negotiation.
 * 
 * Revision 1.17  87/05/13  16:51:04  alexl
 * added the xo_tsdo and xo_tsagree variables
 * 
 * Revision 1.16  87/05/11  15:07:46  davidb
 * PMR002071. New copyright message
 * 
 * Revision 1.15  87/01/16  11:20:58  grant
 * comments only. davidb's cleanup
 * 
 * Revision 1.7  86/12/19  17:44:39  davidb
 * Updating source from Generic trees
 * 
 * Revision 1.6  86/11/05  08:08:17  alexl
 * Updating source from Generic trees
 * 
 * Revision 1.14  86/08/19  19:23:50  mark
 * move subnet mask to end of options, xo_nxmbufs moved to second byte of
 * former subnet mask and grew a byte.
 * 
 * Revision 1.13  86/07/25  14:16:46  mark
 * added tae's changes corresponding to net.O
 * 
 * Revision 1.12  86/07/23  18:29:18  mark
 * syncing revision level
 * 
 * Revision 1.11  86/07/21  12:33:41  mark
 * syncing revision level
 * 
 * Revision 1.10  86/07/17  16:52:10  mark
 * syncing revision level
 * 
 * Revision 1.9  86/07/10  10:36:00  alexl
 * syncing revision level
 * 
 * Revision 1.8  86/06/20  10:11:57  alexl
 * syncing revision level
 * 
 * Revision 1.7  86/06/13  17:06:48  alexl
 * syncing revision level
 * 
 * Revision 1.6  86/06/09  17:57:33  alexl
 * syncing revision level
 * 
 * Revision 1.5  86/06/09  13:58:11  alexl
 * xo_ipba -> xo_udpba to agree with other files
 * 
 * Revision 1.4  86/06/05  16:27:02  alexl
 * added field for broadcast addressing option
 * 
 * Revision 1.4  86/03/25  14:05:05  tae
 * xo_snetmask field added in exosopt
 * 
 * Revision 1.3  85/11/23  09:52:48  tae
 * 3.3A
 * 
 */ 

/*
 * GAP 1/29/85:  W A R N I N G  - This file is included by both host
 * and board code.  Make changes with extreme caution, and test
 * effects on both the host and board sides.
 */

/*
 * Header file for EXOS options.  This structure should be imbedded
 * in the EXOS TCP/IP download module, at the very beginning of
 * initialized data.  The host system may overwrite it to change
 * the default options, BEFORE starting up the onboard code.
 */

#define	XOBIN	(1<<0)		/* TELNET options */
#define	XOECHO	(1<<1)
#define	XOSGA	(1<<3)

struct exosopt {
/*00*/	char	xo_doarp;	/* 1 = use ARP protocol */
/*01*/	char	xo_docksum;	/* 1 = do checksums */
/*02*/	char	xo_useaddr;	/* 1 = use Ethernet address below */
/*03*/	char	xo_ntsconn;	/* up to 8 telnet connections, 0 disables */
/*04*/	char	xo_iaddr[4];	/* Internet address, in network order */
/*08*/	char	xo_eaddr[6];	/* Ethernet address, in network order */
/*14*/	char	xo_tsoffer;	/* bit map of Telnet options to offer */
/*15*/	char	xo_tspermit;	/* bit map of Telnet options to permit */
/*16*/	char	xo_dolink;	/* 1 = enable host access to link mode */
/*17*/	char	xo_npending;	/* number of outstanding host requests */
/*18*/	char	xo_reserve1;	/* reserved (formerly nxmbufs) */
/*19*/	char	xo_xptemp;	/* priority level for PRINTF messages */
/*20*/	char	xo_bufchain;	/* 1 = use NX 5.0 buffer-chaining */
/*21*/	char	xo_reserve2;	/* reserved (formerly subnet mask) */
/*22*/	short	xo_nxmbufs;	/* number of extended memory buffers */
/*24*/	char	xo_reserve3;	/* reserved (formerly subnet mask) */
/*25*/	char	xo_udpba;	/* 0 = force bcast addr to 0's
				 * 1 = force bcast addr to 1's
				 * 2 = do not translate bcast addr */
/*26*/	char	xo_lb;		/* 1 = use 127.0.0.1 as loopback addr */
/*27*/	char	xo_ntcprxmt;	/* number of tcp rexmit before timeout */
/*28*/	char	xo_snetmask[4]; /* subnet address mask */
/*32*/	char	xo_tsdo;	/* bit map of Telnet options to do */
/*33*/	char	xo_tsagree;	/* bit map of Telnet options allow*/
};
	
/*
 * If ARP is enabled, then xo_iaddr must be specified.  Xo_eaddr may
 * be specified;  otherwise the board's given address is used.
 *
 * If ARP is disabled, then a Class A Internet address is derived
 * from the Ethernet address.  The network number is taken from
 * xo_iaddr[0]; if this value is 0xFF, then the default value 89 is
 * used.  In order to emulate other vendor's boards, the Ethernet address
 * may also be specified.
 *
 * If xo_npending is 0, then the TCP/IP configuration code decides how
 * many outstanding host requests to support.
 *
 * If xo_nxmbufs is 0, then the TCP/IP configuration code decides how
 * many extended memory buffers to use.
 *
 * Xo_xptemp determines which printf messages are sent to the host system.
 * For details, see the man page for netload(8).
 */
