/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: xerrno.h,v 1.2 87/04/24 14:42:26 davidb Exp $ */
/*
@(#)xerrno.h	1.3 3/25/85
Error values for xgenlib and xoslib.
Some of these errors will make little sense on non-Unix systems.
Other error numbers should be added for errors which make little
sense on Unix systems.
*/

#define XMINEXERR 0	/* Moved from xperror.c. dab 861217. */
#define XMAXEXERR 71	/* Moved from xperror.c. dab 861217. */

#define	XEPERM		-1		/* Not owner */
#define	XENOENT		-2		/* No such file or directory */
#define	XESRCH		-3		/* No such process */
#define	XEINTR		-4		/* Interrupted system call */
#define	XEIO		-5		/* I/O error */
#define	XENXIO		-6		/* No such device or address */
#define	XE2BIG		-7		/* Arg list too long */
#define	XENOEXEC		-8		/* Exec format error */
#define	XEBADF		-9		/* Bad file number */
#define	XECHILD		-10		/* No children */
#define	XEAGAIN		-11		/* No more processes */
#define	XENOMEM		-12		/* Not enough core */
#define	XEACCES		-13		/* Permission denied */
#define	XEFAULT		-14		/* Bad address */
#define	XENOTBLK		-15		/* Block device required */
#define	XEBUSY		-16		/* Mount device busy */
#define	XEEXIST		-17		/* File exists */
#define	XEXDEV		-18		/* Cross-device link */
#define	XENODEV		-19		/* No such device */
#define	XENOTDIR		-20		/* Not a directory*/
#define	XEISDIR		-21		/* Is a directory */
#define	XEINVAL		-22		/* Invalid argument */
#define	XENFILE		-23		/* File table overflow */
#define	XEMFILE		-24		/* Too many open files */
#define	XENOTTY		-25		/* Not a typewriter */
#define	XETXTBSY		-26		/* Text file busy */
#define	XEFBIG		-27		/* File too large */
#define	XENOSPC		-28		/* No space left on device */
#define	XESPIPE		-29		/* Illegal seek */
#define	XEROFS		-30		/* Read-only file system */
#define	XEMLINK		-31		/* Too many links */
#define	XEPIPE		-32		/* Broken pipe */

/* math software */
#define	XEDOM		-33		/* Argument too large */
#define	XERANGE		-34		/* Result too large */

/* interupt and non-blocking io */
#define	XEWOULDBLOCK	-35		/* Operation would block */
#define	XEINPROGRESS	-36		/* Operation now in progress */
#define	XEALREADY	-37		/* Operation already in progress */

/* argument errors */
#define	XENOTSOCK	-38		/* Socket operation on non-socket */
#define	XEDESTADDRREQ	-39		/* Destination address required */
#define	XEMSGSIZE	-40		/* Message too long */
#define	XEPROTOTYPE	-41		/* Protocol wrong type for socket */
#define	XENOPROTOOPT	-42		/* Protocol not available */
#define	XEPROTONOSUPPORT	-43		/* Protocol not supported */
#define	XESOCKTNOSUPPORT	-44		/* Socket type not supported */
#define	XEOPNOTSUPP	-45		/* Operation not supported on socket */
#define	XEPFNOSUPPORT	-46		/* Protocol family not supported */
#define	XEAFNOSUPPORT	-47		/* Address family not supported by protocol family */
#define	XEADDRINUSE	-48		/* Address already in use */
#define	XEADDRNOTAVAIL	-49		/* Can't assign requested address */

/* operational errors */
#define	XENETDOWN	-50		/* Network is down */
#define	XENETUNREACH	-51		/* Network is unreachable */
#define	XENETRESET	-52		/* Network dropped connection on reset */
#define	XECONNABORTED	-53		/* Software caused connection abort */
#define	XECONNRESET	-54		/* Connection reset by peer */
#define	XENOBUFS		-55		/* No buffer space available */
#define	XEISCONN		-56		/* Socket is already connected */
#define	XENOTCONN	-57		/* Socket is not connected */
#define	XESHUTDOWN	-58		/* Can't send after socket shutdown */
#define	XETOOMANYREFS	-59		/* Too many references: can't splice */
#define	XETIMEDOUT	-60		/* Connection timed out */
#define	XECONNREFUSED	-61		/* Connection refused */

/* random errors */
#define	XELOOP		-62		/* Too many levels of symbolic links */
#define	XENAMETOOLONG	-63		/* File name too long */
#define	XEHOSTDOWN	-64		/* Host is down */
#define XEHOSTUNREACH	-65		/* No route to host */
#define XEXPAND		-66		/* File name expansion error */
#define XEHOSTUNKNOWN	-67		/* Unknown host name */
#define XEFILESTRU	-68		/*Mismatched file and xfer parameters*/
#define XEMKDIR		-69		/* Directory not created */
#define XERMDIR		-70		/* Directory not removed */
#define XEPWD		-71		/* Working directory unknown */
#define XSYSERR		-72		/* unspecified os specific error */

/* -99 is reserved for XEOF, which is not really an error */
/* XLIB errors */
#define XEGRANULARITY	-100		/* buffer not big enough for record */
#define XENOPOSSITION	-101		/* possition within file not defined */
#define XELOSTDATA	-102		/* data was lost at lower level */
