/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: xstat.h,v 1.4 87/04/24 14:43:50 davidb Exp $ */
/*
$Header: xstat.h,v 1.4 87/04/24 14:43:50 davidb Exp $
$Log:	xstat.h,v $
 * Revision 1.4  87/04/24  14:43:50  davidb
 * Fixing copyright message
 * 
 * Revision 1.3  87/03/26  19:18:46  grant
 * Updating source from Generic trees
 * 
 * Revision 1.2  86/10/23  14:53:56  mark
 * added field to xstatbuf for name component of path
 * 
 * Revision 1.1  86/10/10  12:18:36  mark
 * Updating source from Generic trees
 * 
 * Revision 1.1  86/10/07  18:05:39  mark
 * merging in changes for new ftp
 * 
 * Revision 1.2  86/09/09  11:48:12  mark
 * Updating source from Generic trees
 * 
 * Revision 1.1  86/09/04  16:35:37  albert
 * first working version
 * 
 * Revision 1.2  86/08/25  18:18:02  mark
 * syncing revision level
 * 
 * Revision 1.1  86/05/09  15:32:11  mark
 * Initial revision
 * 
*/

struct ftam_attributes {
	int dummy;
};

struct xstatbuf {
	long x_mode;		/* mode flags (defined below) */
	long x_size;		/*length of file in bytes(-1 if inappropriate)*/
	char *x_osinfo;		/* operating system specific information */
	char *x_ncompo;		/* name of file within directory */
	long x_ptype;		/* code for ftp, ftam, nfs, etc. */
	union p_data {
		struct ftp_attr ftp;
		struct ftam_attributes ftam;
	} p_data;
};

/*
Mode flags
*/

#define X_IFMT 0370000	/* type of file */
#define X_IFRECORD 0200000 /* file in record structure */
#define X_IFREG 0100000	/* is a plain file */
#define X_IFDIR 040000	/* is a directory */
#define X_IFTEXT 020000	/* a text file (printable ascii characters,
			   line structure, but no further structure). */
#define X_IFBIN  010000	/* a binary image, representable as a byte stream */
#define X_PREAD 04000	/* read permission, calling process */
#define X_PWRITE 02000	/* write permission, calling process */
#define X_PEXEC 01000	/* execute permission, calling process */
#define X_IREAD 0400	/* read permision, owner */
#define X_IWRITE 0200	/* write permission, owner */
#define X_IEXEC 0100	/* execute permission, owner */
#define X_GREAD 040	/* read permision, group */
#define X_GWRITE 020	/* write permission, group */
#define X_GEXEC 010	/* execute permission, group */
#define X_OREAD 04	/* read permision, others */
#define X_OWRITE 02	/* write permission, others */
#define X_OEXEC 01	/* execute permission, others */

/*
Known Protocol Types
*/
#define P_NATIVE 1	/* local filesystem */
#define P_FTP	2	/* filesystem accessed via FTP */
#define P_FTAM	3	/* filesystem accessed via FTAM */
#define P_NFS	4	/* filesystem accessed via NFS server */
#define P_MSNET	5	/* filesystem accessed via MSNET server */
