/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: ftpconf.c,v 1.4 87/04/24 14:58:07 davidb Exp $ */
/*
$Header: ftpconf.c,v 1.4 87/04/24 14:58:07 davidb Exp $
$Log:	ftpconf.c,v $
 * Revision 1.4  87/04/24  14:58:07  davidb
 * Fixing copyright message
 * 
 * Revision 1.3  87/03/26  19:23:39  grant
 * Updating source from Generic trees
 * 
 * Revision 1.2  86/11/08  10:26:14  albert
 * sendport should be on by default.
 * 
 * Revision 2.5  86/11/06  10:32:34  albert
 * sendport is defaulted to be ON.
 * 
 * Revision 2.4  86/11/04  14:12:37  albert
 * Updating source from Generic trees
 * 
 * Revision 1.1  86/10/07  18:39:21  mark
 * Initial revision
 * 
 * Revision 1.3  86/10/03  16:52:09  mark
 * added variables: stru, type, aborted, sendport
 * 
 * Revision 1.2  86/09/19  13:00:54  albert
 * allow the use of Excelan's standard include file specification.
 * 
 * Revision 1.1  86/09/04  16:03:43  albert
 * Initial revision
 * 
 * Revision 1.1  86/09/04  16:00:38  albert
 * first working version
 * 
 * Revision 1.2  86/08/25  17:04:05  mark
 * syncing revision level
 * 
 * Revision 1.1  86/05/09  14:30:46  mark
 * Initial revision
 * 
*/

#ifdef	vms
#include "h_xlib/xfs.h"
#include "h_xlib/xstdio.h"
#include "h_xlib/xctype.h"
#include "h_xlib/xerrno.h"
#include "h_xlib/xspecial.h"
#include "h_xlib/xcmd.h"
#else	/* vms */
#include <xfs.h>
#include <xstdio.h>
#include <xctype.h>
#include <xerrno.h>
#include <xspecial.h>
#include <xcmd.h>
#endif

#ifdef zilog
#include <setret.h>
#define jmp_buf ret_buf
#else
#ifndef	vms
#include <setjmp.h>
#else 	/* vms */
#include "h_xlib/xsetjmp.h"
#endif	/* vms */
#endif

#ifdef zilog
#define	NULL	(char *)0
#endif

struct filesystem *ccontext = 0;	/* remote context */
struct filesystem *lcontext = 0;	/* local context */
int fromatty = 0;
int doglob = 0;
char line[512] = {0};
int conned = 0;
char **margv = 0;
int margc = 0;
int interactive = 0;
int autologin = 0;
int statistics = 1;
int hash = 0;
int force = 1;		/* force use of service parameters when setting
				local file type */
int xexitonerror = 0;
int debug = 0;
int verbose = 0;
int trace = 0;
int bell = 0;
int stru = 0;
int type = 0;
int aborted = 0;
int sendport = 1;


extern int efsnull();
extern int efsnone();
extern int xnatfsopen();
extern int xnatfsclose();
extern int xnatopen();
extern int xnatstat();
extern int xnatdiropen();
extern int xnatgopen();
extern int xnatchdir();
extern int xnatchattr();
extern int xnatmkdir();
extern int xnatrmdir();
extern int xnatrename();
extern int xnatls();
extern int xnatpwd();
extern int xnatunlink();
extern int xpassthru();
extern int xnatcmd();

extern int xftpfsopen();
extern int xftpfsclose();
extern int xftpsendident();
extern int xftpabort();
extern int xftpopen();
extern int xftpstat();
extern int xftpdiropen();
extern int xftpgopen();
extern int xftpchdir();
extern int xftpchattr();
extern int xftpmkdir();
extern int xftprmdir();
extern int xftprename();
extern int xftpls();
extern int xftppwd();
extern int xftpunlink();
extern int xftpcmd();

struct filesystem fstable[]  = {
	/*
	access routines for native file system
	*/
	{
		NATIVE,
		0,		/* conn_state */
		xnatfsopen,	/* xnatfsopen */
		xnatfsclose,	/* xnatfsclose */
		efsnull,	/* xnatsendident */
		efsnull,	/* xnatabort */
		xnatopen,
		xnatdiropen,
		xnatstat,
		xnatgopen,
		xnatchdir,
		xnatchattr,
		xnatmkdir,
		xnatrmdir,
		xnatrename,
		xnatls,
		xnatpwd,
		xnatunlink,
		xpassthru,
		xnatcmd
	},
	{
		FTP,
		0,		/* conn_state */
		xftpfsopen,	/* xftpfsopen */
		xftpfsclose,	/* xftpfsclose */
		xftpsendident,	/* xftpsendident */
		xftpabort,	/* xftpabort */
		xftpopen,
		xftpdiropen,
		xftpstat,
		xftpgopen,
		xftpchdir,
		xftpchattr,
		xftpmkdir,
		xftprmdir,
		xftprename,
		xftpls,
		xftppwd,
		xftpunlink,
		xpassthru,
		xftpcmd
	}
};

struct filesystem *end_fstable =
	&fstable[ sizeof( fstable ) / sizeof( struct filesystem ) ];

/*
decide what file access protocol to use
*/
xgetfsid( host )
	char *host;
{
	if( host && *host )
		return( FTP );
	return( NATIVE );
}
