/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: ftpdstart.c,v 1.2 87/04/24 14:59:22 davidb Exp $ */
#ifndef lint
static char sccsid[] = " @(#)ftpdstart.c	1.8 5/31/85";
#endif

/*
 * FTP server.
 */
#ifdef scoxenix5
#include <sys/types.h>
#include <sys/param.h>
#else	/* scoxenix5 */

#include <sys/param.h>
#ifdef SYSTEM5
#include <sys/types.h>
#endif

#endif	/* scoxenix5 */
#include <sys/stat.h>
#if   !( xenix286 || xenix086 )
#include <sys/ioctl.h>
#endif
#include <xstdio.h>
#include <stdio.h>
#include <signal.h>
#include <pwd.h>
#include <errno.h>
#include <sys/soioctl.h>	/* For SIGURG */

#include <arpa/ftp.h> /* Used to be "ftp.h". dab 861125. */
#include <netinet/in.h>
#include <sys/socket.h>

/*
   The following mapping of dup2 to fcntl used to be in compat.h,
   and was keyed off the definition of index as a macro, instead
   of SYSTEM3/5 directly. dab 861121.
*/

#if SYSTEM3 || SYSTEM5 /* system 3 or 5 */
#include <fcntl.h>
#define dup2(f,n) { close(n); fcntl(f, F_DUPFD, n);}
#endif	/* SYSTEM3 || SYSTEM5 */

#define VOID 		(int)/* Used to be in compat.h. dab 861126. */

extern	char version[];
extern	int xsmain();
extern	int lostconn();

extern struct	sockaddr_in ctrl_addr;
struct	_xiobuf _xiob[_XNFILE];
int xmodname();
int hash = 0;

extern int	logged_in;
extern int	debug;
extern int	timeout;
extern int	logging;
extern int	guest;

abort( )
{
	signal( SIGURG, abort );
}


main(argc, argv)
	int argc;
	char *argv[];
{
	int ctrl, s, options = 0;
	char *cp;
	int rval;
	int rval2;

	ctrl_addr.sin_port = htons(IPPORT_FTP);
	ctrl_addr.sin_family = AF_INET;
	options = ( SO_ACCEPTCONN | SO_KEEPALIVE );
	signal(SIGINT, SIG_IGN);
	signal(SIGHUP, SIG_IGN);
	signal(SIGURG, abort );
	debug = 0;
	argc--, argv++;
	while (argc > 0 && *argv[0] == '-') {
		for (cp = &argv[0][1]; *cp; cp++) switch (*cp) {

		case 'v':
			debug = 1;
			break;

		case 'd':
			debug = 1;
			options |= SO_DEBUG;
			break;

		case 'l':
			logging = 1;
			break;

		case 't':
			timeout = atoi(++cp);
			goto nextopt;
			break;

		default:
			fprintf(stderr, "Unknown flag -%c ignored.\n", *cp);
			break;
		}
nextopt:
		argc--, argv++;
	}
	if (fork())
		exit(0);
	for (s = 0; s < 10; s++)
		if (!logging || (s != 2))
			VOID close(s);
	VOID open("/", 0);
	dup2(0, 1);
	if (!logging)
		{
		dup2(0, 2);
		}
	else
		{
		rval = xuxtex( 2 );
		fprintf( stderr, "rval = %d\n", rval );
		rval2 = xdup2( rval, 2 );
		if( rval2 < 0 )
			xperror( rval2, "xdup2" );
		else
			xodopen( 2, "w" );
		if( rval != 2 )
			{
			xclose( rval );
			}
		}
	getclient( SOCK_STREAM, (struct sockproto *)0,
		&ctrl_addr, options, xsmain);
}

xsmain( s, from )

/*
Unix specific ftp demon start up actions, calls generic code.
Operating systems which require the user's id to be established
before the process is started may provide two versions of this
module, one where logged_in is set to zero and one where it
is set to 1.
Otherwise, this is where to determine if the user has been authenticated
or not.
*/
int s;
struct sockaddr_in *from;
{
int cowscomehome = 0;

	signal(SIGPIPE, lostconn);
	logged_in = 0;
	/*
	Until xprintf is available...
	s = (int)_xiob[s]._sys_id;
	*/
	s = xuxtex( s );
	if ( s < 0 )
		{
		xperror( s, "xuxtex failed" );
		xexit( 1 );
		}
	ftpdoit( s, from );
	if( cowscomehome )
		xmodname();	/* force linker to resolve circular reference */
}
