/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: sender.c,v 1.2 87/04/24 15:26:36 davidb Exp $ */
/*********************************************************************

			Sender Side


*********************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>

struct sockaddr_in send_socket = { AF_INET };
struct sockaddr_in recv_socket = { AF_INET };

#define MAXBUF		8192

extern int errno;
int fdw = 0;			/* sender socket desriptor */
int fdr = 0;			/* input data from read file descriptor */
int filefd = 0;			/* input data file, intialize to stdin */
char buf[MAXBUF] = {0} ;	/* send buffer */
char *hostname = "";		/* receiver's host name */
char *filename = "";		/* input file name */
int bufsize = 1024;		/* size of send buffer */
int cnt = 0;			/* number of bytes sent */
int options = 0;		/* socket options */
short port = 2000;		/* base port address for the connection */
portoff = 0;			/* port offset to the base port address */
int socket_type = 0;		/* socket type - TCP/IP */
short	status = 0;		/* return status */
int debug = 1;			/* do print debug messages */
long addr;			/* internet address */
long rhost();

main(argc,argv)
char **argv;
{
int an;

	/* process arguments */

      for( an = 1; an < argc ; ++an )
      if( argv[an][0] == '-' ) {
	switch ( argv[an][1] ) {
	  case 'z':
		/*
		set bufffer si'z'e.
		*/
		if( an < argc){
			bufsize = atoi(argv[++an]);
			if ((bufsize <= 0) || (bufsize > MAXBUF)){
				fprintf(stderr,"sender:illegal buffer size\n");
				exit(1);
			}
		fprintf(stderr,"sender:bufsize = %d\n", bufsize);
		}else {
		  fprintf(stderr,"expected buffer size\n");
		  exit(1);
		}
		break;
	  case 'o':	/* port offset, which is added to base port # */ 
		if( an < argc){
			portoff = atoi( argv[++an]);
		}else {
		  fprintf(stderr,"expected port offset\n");
		  exit(1);
		}
		break;
	  case 'h':	/* receiver's host name */
		if( an < argc){
 		  hostname = argv[++an];
		  if((addr = rhost(&hostname)) == -1) {
			fprintf(stderr,"%s is and illegal hostname",hostname);
			exit(1);
		  }
		}else {
		  fprintf(stderr,"expected hostname\n");
		  exit(1);
		}
		break;
	  case 'f':	/* name of file to transfer */
		if( an < argc) {
		   filename = argv[++an];
		   filefd = open( filename, 0 );
		   if(filefd < 0)
			fprintf(stderr,"can not open filename");
		} else {
		  fprintf(stderr,"expected file name");
		  exit(1);
		}
		break;
		  
	  default : 
		break;
	  } /* end of switch */
	} /* end of if */
/*******************************************************************
	Initialize the both the sender socket and set the internet
	address(including port address) of the partner.
********************************************************************/
	socket_type = SOCK_STREAM; 
	send_socket.sin_port = htons((port << 1)+ portoff);
	recv_socket.sin_port = htons(port + portoff);
	recv_socket.sin_addr.s_addr = addr;
	fdr = filefd;
/******************************************************************
	Socket call
******************************************************************/
	if ((fdw = socket(socket_type, (struct sockproto *)0,
		 &send_socket, options)) < 0) {
		experror("socket");
		exit(0);
	}	
	fprintf (stderr,"socket fd= %d\n", fdw);
/******************************************************************
	Connection request
******************************************************************/
	fprintf( stderr,"posting connection request, port = %d\n",port+portoff);
	if((status = connect(fdw, &recv_socket)) < 0){
		experror("connect" );
		fprintf( stderr, "fdw = %d\n", fdw );
		exit(1);
	}
	fprintf(stderr,"connected to partner\n");
/******************************************************************
	Send the file or input from the keyboard to the receiver
	side.
******************************************************************/
	while( 1 ){
		if((cnt=read(fdr,buf,bufsize)) > 0 )
			cnt = write(fdw,buf,cnt);
		if( cnt <= 0 )
			break;
		else {
			if( debug )
				fprintf(stderr,"wrote %d bytes\n", cnt );
		}
	}
}
