/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: rhost.c,v 1.2 87/04/24 16:07:34 davidb Exp $ */
#include <stdio.h>
#include <ctype.h>
#include <netinet/in.h>

static char sccsId[] = "@(#)rhost.c	1.8 10/14/85";

#ifdef SYSTEM5
#define	index(s,c) strchr(s,c)
#define rindex(s,c) strrchr(s,c)
extern char *strchr(), *strrchr();
#else
extern char	*index(), *rindex();
#endif

/* this mess fixes bug in unisoft V7 callan port - GAP 1-13-84 */
#ifdef cadmus
#undef isxdigit
#define isxdigit(c) (isdigit(c)||((c>='A'&&c<='F')||(c>='a'&&c<='f')))
#else
#ifdef VERSION7
#undef isxdigit
#define isxdigit(c) (isdigit(c)||((c>='A'&&c<='F')||(c>='a'&&c<='f')))
#endif
#endif

char	*malloc();
long    rnumber();
char	*firstwhite();
char	*lastwhite();
char	*skipwhite();

long
rhost(ahost)
	char **ahost;
{
	FILE *hf;
	char hbuf[BUFSIZ], *cp;
	int first = 1;
	long addr;
	char *endp;

	if (isdigit(**ahost) && (addr = rnumber(*ahost)) != -1) {
		return (addr);
	}
	hf = fopen(HOSTS, "r");
	if (hf == NULL) {
		experror(HOSTS);
		return( -1 );
	}
top:
	while (fgets(hbuf, sizeof (hbuf), hf)) {
		if (hbuf[0] == '#')
			continue;
		if( endp = index(hbuf, '#') ) {
			*endp = 0;
		} else {
			*index(hbuf, '\n') = 0;
		}
		for (;;) {
			cp = lastwhite(hbuf, ' ');
			if (cp == NULL)
				break;
			if (!strcmp(cp+1, *ahost)) {
				if ((addr = rnumber(hbuf)) == -1)
					goto bad;
				fclose(hf);
				*ahost = firstwhite(hbuf, ' ') + 1;
				*ahost = skipwhite( *ahost );
				cp = firstwhite(*ahost, ' ');
				if (cp)
					*cp = 0;
				cp = malloc(strlen(*ahost)+1);
				strcpy(cp, *ahost);
				*ahost = cp;
				return (addr);
			}
			*cp = 0;
		}
	}
	if (first == 1) {
		first = 0;
		fclose(hf);
		if (hf = fopen(HOSTSLOCAL, "r"))
			goto top;
		return (-1);
	}
bad:
	fclose(hf);
	return (-1);
}

long
rnumber(cp)
	register char *cp;
{
	register long val;
	register int base;
	register char c;
	long parts = 0;
	char *pplow = (char *)&parts;
	char *pplim = pplow+4;
	char *pp = pplow;
	long net, imp, hoi;

	if (index(cp, '/') == 0)
		goto again;
	hoi = atoi(cp);
	if (index(cp, ',')) {
		imp = atoi(index(cp, '/') + 1);
		net = atoi(index(cp, ',') + 1);
		hoi = ntohs((short)hoi);
		val = (net<<24)|(hoi<<8)|imp;
	} else {
		net = atoi(index(cp, '/') + 1);
		val = (net<<24)|hoi;
	}
	/*
	val = htonl(val);
	*/
	return (val);

again:
	val = 0; base = 10;
	if (*cp == '0')
		base = 8, cp++;
	if (*cp == 'x' || *cp == 'X')
		base = 16, cp++;
	while (c = *cp) {
		if (isdigit(c)) {
			val = (val * base) + (c - '0');
			cp++;
			continue;
		}
		if (base == 16 && isxdigit(c)) {
			val = (val << 4) + (c + 10 - (islower(c) ? 'a' : 'A'));
			cp++;
			continue;
		}
		break;
	}
	if (*cp == '.') {
		/*
		 * Internet format:
		 *	net.host.lh.imp
		 */
		if (pp >= pplim)
			return (-1);
		*pp++ = val, cp++;
		goto again;
	}
	if (*cp) {
		/*
		if (*cp == 'n') return (htonl(val));
		*/
		if (*cp == 'n') return (val);
		if ( *cp != ' '&& *cp != '\t' ) return (-1);
	}
	if (pp >= pplim)
		return (-1);
	*pp++ = val;
	/*
	return htonl(parts);
	*/
	return (parts);
}

char *
skipwhite( cpt )

char *cpt;
{

	while( cpt && ( *cpt == ' ' || *cpt == '\t' ))
		++cpt;
	return ( cpt );
}


char *
firstwhite( cpt, ch )
/*
find first white space
*/

char *cpt;
char ch;
{

	while( cpt && *cpt && *cpt != ' ' && *cpt != '\t' )
		++cpt;
	if ( cpt && *cpt ) {
		return( cpt );
	}
	return ( NULL );
}

char *
lastwhite( cpt, ch )
/*
find last white space
*/

char *cpt;
char ch;
{
char *ocpt = NULL;

	while( ( cpt = firstwhite( cpt, ' ' ) ) != NULL ) {
		ocpt = cpt;
		cpt++;
	}
	return( ocpt );
}
