/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: ftplib.h,v 1.4 87/04/24 16:13:02 davidb Exp $ */
/*
$Header: ftplib.h,v 1.4 87/04/24 16:13:02 davidb Exp $
$Log:	ftplib.h,v $
 * Revision 1.4  87/04/24  16:13:02  davidb
 * Fixing copyright message
 * 
 * Revision 1.3  87/03/26  19:35:10  grant
 * Updating source from Generic trees
 * 
 * Revision 1.2  87/01/19  15:49:50  grant
 * davidb's cleanup, header stuff.
 * 
 * Revision 1.7  86/12/19  17:57:44  davidb
 * Updating source from Generic trees
 * 
 * Revision 1.3  86/11/05  08:24:30  alexl
 * Updating source from Generic trees
 * 
 * Revision 1.1  86/10/08  10:38:17  mark
 * merging in changes for new ftp
 * 
 * Revision 1.5  86/09/29  16:32:57  mark
 * added defines for record marks
 * 
 * Revision 1.4  86/09/19  09:29:30  albert
 * allow use of Excelan's standard include file specification.
 * 
 * Revision 1.3  86/09/10  10:36:32  albert
 * should use Excelan standard style of include specification.
 * 
 * Revision 1.2  86/09/08  11:59:43  albert
 * change the size of default directory.
 * 
 * Revision 1.2  86/08/25  17:28:00  mark
 * syncing revision level
 * 
 * Revision 1.1  86/05/09  14:23:52  mark
 * Initial revision
 * 
*/

#ifdef	vms
#include "h_xlib/xstdio.h"
#include "h_xlib/xfs.h"
#include "h_xlib/xspecial.h"
#include "h_xlib/xstat.h"
#include "h_xlib/xerrno.h"
#include "h_xlib/xproto.h"
#include "h_xlib/xftpio.h"
#include "h_xlib/xctype.h"
#include "h_xlib/xlseek.h"
#else	/* vms  */
#include <xstdio.h>
#include <xfs.h>
#include <xspecial.h>
#include <xstat.h>
#include <xerrno.h>
#include <xproto.h>
#include <xftpio.h>
#include <xctype.h>
#include <xlseek.h>
#endif  /* vms */

#define MAXNAMLEN 255

#ifdef	vms
#include "h_xlib/xdir.h"
#include "h_xlib/xcmd.h"
#include "h_xlib/telnet.h"
#include "h_xlib/socket.h"
#include "h_xlib/soioctl.h"
#include "h_xlib/in.h"
#else 	/* vms */
#include <xdir.h>
#include <xcmd.h>
#include <xtelnet.h> 	/* Xlib specific stuff. Used to be in */
#include <arpa/telnet.h> /* include/EXOS/telnet.h. dab 861125. */
#include <sys/socket.h>
#include <sys/soioctl.h>
#include <netinet/in.h>
#endif	/* vms */

#define VOID (int)

extern int xftpread();
extern int xftpioctl();
extern long xftplseek();
extern int xftpwrite();
extern int xftpclose();

#define PRELIM 1	/* preliminary response */
#define COMPLETE 2	/* success response */
#define CONTINUE 3	/* more information needed response */
#define ERROR 5		/* rejection response */

#define SWAITMAX 90	/* maximum number of seconds to wait for an address to
			   free up */
#define SWAITINT 5	/* interval at which to retry socket */

/*
 * defines for record structure transfer
 */
#define	RECORD_ESCAPE	'\377'
#define END_OF_FILE	'\002'
#define END_OF_RECORD	'\001'

#ifdef	vms
#define SCRATCHFILE "SYS$LOGIN:ftpXXXXXX"
#define PWDLEN 256
#else
#define PWDLEN 64
#define SCRATCHFILE "/tmp/ftpXXXXXX"
#endif
