/*	Copyright (c) 1985,1986,1987  EXCELAN, INC. 	*/
/*	  All Rights Reserved.                         	*/

/*	The copyright notice above does not evidence any 	*/
/*	actual or intended publication. 			*/

/*	THIS IS UNPUBLISHED COMPUTER SOFTWARE CONTAINING TRADE SECRETS 	*/
/*	AND CONFIDENTIAL INFORMATION PROPRIETARY TO EXCELAN, INC. 	*/

/* $Header: xtelopen.c,v 1.4 87/04/24 16:47:29 davidb Exp $ */



/*
$Header: xtelopen.c,v 1.4 87/04/24 16:47:29 davidb Exp $
$Log:	xtelopen.c,v $
 * Revision 1.4  87/04/24  16:47:29  davidb
 * Fixing copyright message
 * 
 * Revision 1.3  87/03/26  19:40:11  grant
 * Updating source from Generic trees
 * 
 * Revision 1.2  87/01/19  16:50:16  grant
 * davidb's cleanup. header stuff.
 * 
 * Revision 1.7  86/12/19  18:00:39  davidb
 * Updating source from Generic trees
 * 
 * Revision 1.3  86/11/05  08:27:58  alexl
 * Updating source from Generic trees
 * 
 * Revision 1.1  86/10/08  10:50:38  mark
 * merging in changes for new ftp
 * 
 * Revision 1.4  86/09/19  10:17:37  albert
 * 1. allow use of Excelan's standard include file specification.
 * 2. Use symbolic name (instead of a constant) for TELNET object.
 * 
 * Revision 1.3  86/09/18  14:53:09  albert
 * Use a symbol (rather than a hard-coded number) to represent telnet object.
 * 
 * Revision 1.2  86/09/10  10:45:43  albert
 * use Excelan's standard style of include specification.
 * 
 * Revision 1.1  86/09/04  16:19:34  albert
 * first working version
 * 
 * Revision 1.2  86/08/25  17:47:05  mark
 * syncing revision level
 * 
 * Revision 1.1  86/04/18  19:13:06  mark
 * Initial revision
 * 
*/

#ifdef	vms
#include "h_xlib/xstdio.h"
#include "h_xlib/telnet.h"
#include "h_xlib/xerrno.h"
#else	/* vms */
#include <xstdio.h>
#include <xtelnet.h> 	/* Xlib specific stuff. Used to be in */
#include <arpa/telnet.h> /* include/EXOS/telnet.h. dab 861125. */
#include <xerrno.h>
#endif

extern int errno;
extern char *xmalloc();
extern int xtelread();
extern int xtelioctl();
extern int xtelwrite();
extern int xtelclose();

xtelopen( od, nvt_action, esc_action )

int od;		/* socket being used for telnet connection */
int (*nvt_action)();	/* to call when telnet sequence recognized */
int (*esc_action)();	/* to call when escape character written */
{
int i;
int exosfd;
register XFILE *file;
XFILE *file2;
register struct tel_state *telpt;

if( od < 0 || od >= _XNFILE )
	return( XEBADF );
file2 = &_xiob[od];
exosfd = xnewod();		/* get a free file descriptor */
if( exosfd < 0 )
	{
	return( exosfd );
	}
/*
Allocate space for telnet state.
And initialize it.
*/
telpt = (struct tel_state *)xmalloc( sizeof( struct tel_state ) );
if( telpt == (struct tel_state *) XNULL )
	return( XENOMEM );
telpt->od = od;
telpt->nvt_action = nvt_action;
telpt->esc_action = esc_action;
for( i = 0 ; i < 255 ; ++i )
	{
	telpt->his_opts[i] = 0;
	telpt->my_opts[i] = 0;
	}
telpt->escape = 0;
telpt->read_state = 0;
telpt->write_state = 0;
file = &_xiob[exosfd];
file->_flag |= file2->_flag & ( _XIOREAD | _XIOWRT | _XIORW );
file->_sys_id = (char *)telpt;
file->_read = xtelread;
file->_ioctl = xtelioctl;
file->_write = xtelwrite;
file->_close = xtelclose;
file->_odtype = TELNET_OBJECT;
return( exosfd );
}
